(**************************************************************************)
(*                           Jeu des allumettes                           *)
(**************************************************************************)

include "minmax";;

type configuration == bool * int ;;

let (configuration_initiale : configuration) = true, 20 ;;

let (suiv : configuration -> configuration list) = fun (b,n) ->
  map (fun n' -> not b,n') (match n with
    0 -> []
  | 1 -> [0]
  | 2 -> [0 ; 1]
  | n -> [n-3 ; n-2 ; n-1])
;;

let (eval : configuration -> float) = fun (b,n) -> match n with
    0 -> 1.0
  | _ -> 0.5
;;

let joue ((b,n) as c) = fst (minmax_n eval suiv (n/2+1) c) ;;

let affiche_configuration (b,n) =
  print_string (if b then "au joueur 1 : " else "au joueur 2 : ") ;
  for i = 1 to n do
    print_string "|"
  done ;
  print_newline ()
;;

let boucle coup ci =
  let rec boucle_rec ((b,n) as c) =
    if n = 0 then begin
      print_string (if b then "le joueur 1 gagne !"
		    else "le joueur 2 gagne !") ;
      print_newline ()
    end else begin
      affiche_configuration c ;
      boucle_rec (coup c)
    end
  in
    boucle_rec ci
;;

