
let sqrt_big_int n =
  let rec sqrt_rec k sqk =
    if eq_big_int n sqk then
      k
    else if lt_big_int sqk n then
      let sqk' = add_big_int sqk 
                            (add_big_int (mult_big_int deux k) unit_big_int) in
      sqrt_rec (succ_big_int k) sqk'
    else
      pred_big_int k
  in
  if lt_big_int n zero_big_int then
    raise (Invalid_argument "sqrt_big_int")
  else
    sqrt_rec zero_big_int zero_big_int
;;

let sqrt n =
  let rec puiss2 l dpk k = 
    if gt_big_int (square_big_int dpk) n then
      l,k
    else
      puiss2 (dpk::l) 

  if lt_big_int n zero_big_int then
    raise (Invalid_argument "sqrt_big_int")
  else if eq_big_int n zero_big_int then
    zero_big_int
  else
    let l,k = puiss2 
    sqrt_rec zero_big_int zero_big_int
;;


let deux = big_int_of_int 2;;

let sqrt n =
  let rec dicho a b =
    if le_big_int (sub_big_int b a) unit_big_int then
      a 
    else
      let m = div_big_int (add_big_int a b) deux in
      let fm = sub_big_int (square_big_int m) n in
      if eq_big_int fm zero_big_int then
        m
      else if lt_big_int fm zero_big_int then
        dicho m b
      else
        dicho a m  
  in
  if lt_big_int n zero_big_int then
    raise (Invalid_argument "sqrt_big_int")
  else if eq_big_int n zero_big_int then
    zero_big_int
  else if eq_big_int n unit_big_int then
    unit_big_int
  else
    dicho zero_big_int n
;;


let coded_string s =
  let n = string_length s in 
  let s' = create_string (2 * n) in
  for i=0 to n-1 do
    let a = string_of_int (int_of_char (nth_char s i)) in
    set_nth_char s' (2*i) (nth_char a 0) ;
    set_nth_char s' (2*i + 1) (nth_char a 1) 
  done ;
  s'
;;

(* message RSA *)

let x = big_int_of_string "843589";;

let x = big_int_of_string "17669";;
let y = big_int_of_string "2819";;
let s = big_int_of_string "843589";;

let N = mult_big_int x y;;
let m = mult_big_int (pred_big_int x) (pred_big_int y);;
let p = div_mod unit_big_int s m;;

(* verif *)
let ps = mult_big_int p s ;;
mod_big_int ps m;; (* =1 *)

let M = map (fun s -> big_int_of_string (coded_string s))
            [ "CAM" ; "L E" ; "ST " ; "VRA" ; "IME" ; "NT " ; 
              "UN " ; "SUP" ; "ER " ; "LAN" ; "GAG" ; "E. " ]
;;

let rec power_mod N x n =
 let rec power x n =
  if eq_big_int n zero_big_int then
    unit_big_int
  else if eq_big_int n unit_big_int then
    mod_big_int x N
  else
    let q,r = quomod_big_int n deux in
    let xq = mod_big_int (square_big_int (power x q)) N in
    if eq_big_int r zero_big_int then
      xq
    else
      mod_big_int (mult_big_int x xq) N

 in power x n
;;

let cM = map (fun x -> mod_big_int (power_mod N x p) N) M
;;

(* le message cod :

 [41021358; 1169160; 31809925; 17484908; 32136910; 30925474; 22255997;
  48565640; 37770004; 48144453; 6582428; 39919725]

*)

let dcM = map (fun x -> mod_big_int (power_mod N x s) N) cM
;;
